routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['auth', 'app.menu']], function () {    
    Route::resource('users', 'Admin\UserController');
    Route::resource('categories', 'Admin\CategoryController');
    Route::resource('units', 'Admin\UnitController');
    Route::resource('products', 'Admin\ProductController');
    Route::resource('inputs', 'Admin\InputController');
    Route::resource('outputs', 'Admin\OutputController');
    Route::resource('clients', 'Admin\ClientController');
    Route::resource('deliveries', 'Admin\DeliveryController');
    Route::resource('cashcuts', 'Admin\CashcutController');
    Route::resource('materials', 'Admin\MaterialController');
    Route::get('deliveries_credit', 'Admin\DeliveryController@deliveryCredit')->name('deliveries.credit.index');
    Route::get('deliveries_normal', 'Admin\DeliveryController@deliveryNormal')->name('deliveries.normal.index');
    //Exports
    Route::get('productsExport', 'Admin\ProductController@productsExport')->name('products.export');
    Route::post('productsImport', 'Admin\ProductController@productsImport')->name('products.import');
    //ProductsSupply
    Route::get('productsSupply', 'Admin\ProductController@productsSupply')->name('products.supply');  
    Route::get('deliveriescredit', 'Admin\DeliveryController@getDeliveriesCredit')->name('deliveries.credit');  
    Route::get('products/sold/filter', 'Admin\ProductController@soldFilter')->name('products.sold.filter');
     
});

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');
 
Route::group(['middleware' => ['auth', 'app.menu']], function () {    
    Route::get('/', 'Admin\HomeController@index')->name('home');
});

app/Models/Category.php
<?php

namespace App\Models;

class Category extends Model
{    
    protected $fillable = [
        'id', 'name', 'status',
    ];


    public $rules = [
        'name' => 'required|max:50|unique:categories,name'
    ];

    public function products() {
        return $this->hasMany(\App\Models\Product::class);
    }

}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use DataTables;
use App\Models\Role;
class CategoryController extends Controller
{
    protected $resourceName = 'categories';
    protected $resourceClass = \App\Models\Category::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct() {}    

    protected function rulesValidations($item = null){
        $item->rules['name']= 'required|max:50|unique:categories,name,'.$item->id;
    }
    
    
}

app/Http/Controllers/Api/CategoryController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DataTables;
class CategoryController extends Controller
{
    protected $resourceName = 'categories';

    protected $resourceClass = \App\Models\Category::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        

    }

    public function datatables() {
        $items = $this->resourceClass::orderDesc()->get();        
        $datatable = DataTables::collection($items);
        $this->columns($datatable);
        $datatable->rawColumns(['actions']);
        return $datatable->make(true);
    }

    private function columns(&$datatable) {
        $datatable->editColumn('status', function ($item) {
                return __('general.' . ($item->status ? 'active' : 'inactive'));
            })->editColumn('created_at', function ($item) {
                return $item->created_at->format("d/m/Y H:i");
            })->editColumn('actions', function ($item) {
            return view('common.actions', [
                "edit" => true,
                "routeEdit" => route("admin.$this->resourceName.edit", ['category' => $item->id]),
            ])->render();
        });
    }
}

resources/views/admin/categories/form.blade.php
<div class="row">
    @include('common.input', [
        "id" => "name",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('general.name'),
        "value" => (isset($item->name) ? $item->name : old('name'))
    ])
    @include('common.select', [
        "id" => "status",
        "clas" => "col-md-6",
        "label" => __('general.datatables.status'),
        "options" => [
            "1" => __('general.active'),
            "0" => __('general.inactive'),
        ],
        "value" => (isset($item->status) ? $item->status : old('status'))
    ])
    
</div>

resources/views/admin/categories/index.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">@lang('general.administration', ['model' => __('navigation.menu.categories')])</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                <a href="{{ route('admin.categories.create') }}" class="btn btn-outline-primary float-right"><i class="fas fa-plus"></i> @lang('general.add')</a>
                <a href="{{ route('home') }}" class="btn btn-outline-dark"><i class="fas fa-long-arrow-alt-left"></i> @lang('general.cancel')</a>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                @include('common.table', [
                    "resource" => "categories",
                    "headers" => [
                        "name" => __('general.name'),
                        "status" => __('general.datatables.status'),
                        "created_at" => __('general.datatables.created_at'),
                        "actions" => __('general.datatables.actions'),
                    ],
                    "url" => route('api.categories.datatables')
                ])
            </div>
        </div>
    </x-content>
@endsection

resources/views/admin/categories/item.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">{{ __('general.' . (isset($item) ? 'edit' : 'add')) }} @lang('general.category')</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                @component('components.form', [
                    "item" => (isset($item) ? $item : null),
                    "resource" => "categories",
                    "back" => route('admin.categories.index'),
                    "updateResource" => "category"
                ])
                @include('admin.categories.form', ['item' => (isset($item) ? $item : null)])
                @endcomponent
            </div>
        </div>        
    </x-content>
@endsection